/* mna3d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer iter;
} mna3rr_;

#define mna3rr_1 mna3rr_

/* Subroutine */ int mna3d_c(D_fp f, doublereal *a, doublereal *b,
        doublereal *c__, doublereal *eps, doublereal *xmin, doublereal *fmin, integer *
        iflag, integer *itmax)
{
    /* Initialized data */

    static doublereal cgold = .381966;
    static doublereal zeps = 1e-10;
    static doublereal zero = 0.;

    /* System generated locals */
    integer i__1;
    doublereal d__1;

    /* Builtin functions */
    double d_sign(doublereal *, doublereal *);

    /* Local variables */
    static doublereal d__, e;
    static integer i__;
    static doublereal p, q, r__, u, v, w, x, etemp, ax, bx, fu, fv, fw, fx, 
            cx, xm, tol1, tol2;

    *iflag = 0;
    ax = *a;
    bx = *b;
    cx = *c__;
    *a = min(*a,*c__);
    *b = max(*a,*c__);
    v = bx;
    w = v;
    x = v;
    e = zero;
    fx = (*f)(&x);
    fv = fx;
    fw = fx;
    i__1 = *itmax;
    for (i__ = 1; i__ <= i__1; ++i__) {
        mna3rr_1.iter = i__;
        xm = (*a + *b) * .5;
        tol1 = *eps * abs(x) + zeps;
        tol2 = tol1 * 2.;
        if ((d__1 = x - xm, abs(d__1)) <= tol2 - (*b - *a) * .5) {
            goto L150;
        }
        if (abs(e) <= tol1) {
            goto L10;
        }
        r__ = (x - w) * (fx - fv);
        q = (x - v) * (fx - fw);
        p = (x - v) * q - (x - w) * r__;
        q = (q - r__) * 2.;
        if (q > zero) {
            p = -p;
        }
        q = abs(q);
        etemp = e;
        e = d__;
        if (abs(p) >= (d__1 = q * .5 * etemp, abs(d__1)) || p <= q * (*a - x) 
                || p >= q * (*b - x)) {
            goto L10;
        }
        d__ = p / q;
        u = x + d__;
        if (u - *a < tol2 || *b - u < tol2) {
            d__1 = xm - x;
            d__ = d_sign(&tol1, &d__1);
        }
        goto L40;
L10:
        if (x < xm) {
            goto L20;
        }
        e = *a - x;
        goto L30;
L20:
        e = *b - x;
L30:
        d__ = cgold * e;
L40:
        if (abs(d__) < tol1) {
            goto L50;
        }
        u = x + d__;
        goto L60;
L50:
        u = x + d_sign(&tol1, &d__);
L60:
        fu = (*f)(&u);
        if (fu > fx) {
            goto L90;
        }
        if (u < x) {
            goto L70;
        }
        *a = x;
        goto L80;
L70:
        *b = x;
L80:
        v = w;
        fv = fw;
        w = x;
        fw = fx;
        x = u;
        fx = fu;
        goto L110;
L90:
        if (u >= x) {
            goto L100;
        }
        *a = u;
        goto L110;
L100:
        *b = u;
L110:
        if (fu <= fw || w == x) {
            goto L120;
        }
        if (fu <= fv || v == x || v == w) {
            goto L130;
        }
        goto L140;
L120:
        v = w;
        fv = fw;
        w = u;
        fw = fu;
        goto L140;
L130:
        v = u;
        fv = fu;
L140:
        ;
    }
    goto L160;
L150:
    *iflag = 1;
L160:
    *a = ax;
    *b = bx;
    *c__ = cx;
    *xmin = x;
    *fmin = fx;
    return 0;
} /* mna3d_c */
